function code_A = ... % these are matrices of sizes of A,B holding the calculated code per patch] = ... % this is for statistics (internal)
    BuildWalshHadamardCodes_VIDEO2(tableInd,width,currFiltImgs_A,filters,binMapsForUse,hA,wA,insideInfo,classType)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% A] INITIALIZATIONS
maxFilterRange = 2*256*width*width*width+1;%always odd
minFilterValue = -floor(maxFilterRange/2);


% maxIterations = max(filters);
num_of_filters_for_coding = length(filters);

code_A = zeros(hA,wA,'uint32');

debugDisp(insideInfo,['>>>>>>>>> Coding table number ' num2str(tableInd)   ' >>>>>>>']);


%% A] BUILDING OF CODES for A and B (iterating through the kernels)
% at each iteration we append to the code the bin index
% of the patch projected on the current WH code

for filter_ind = 1:num_of_filters_for_coding
    current_filter = filters(filter_ind);
      
    % retrieve current filter applied on A
    currFiltImg_A = currFiltImgs_A{current_filter};
    
    % get the pre-computed binmap
    binMapForUse = binMapsForUse(filter_ind,:);
    
    
    % Construct the code image
    % ------------------------
    
    d1 = currFiltImg_A - minFilterValue;
    
    useC = 1;
    if (useC)
        if (strcmp(classType,'int16'))
            bins_A = CalculateImageOfBinIndices_16s_VIDEO(binMapForUse,d1); % MEX function
        else
            bins_A = CalculateImageOfBinIndices_32s_VIDEO(binMapForUse,d1); % MEX function
        end
    else
        bins_A = binMapForUse(d1);
    end
    
    % appending the current bin numbers the forming code
    code_A = bitor(code_A, bins_A);
        
end                       % end maxIterations on kernels loop

