function [patchesYCbCr,patchesRGB] = CreateArrayOfRotatedPatches(imRGB,winnerOrientations,width)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% the patchesRGB of the boundary shouldn't be rotated as is, so we pad appropriatelly
padSize = ceil((sqrt(2)-1)*width/2);
paddedRGB = padarray(imRGB,[padSize,padSize],'symmetric');

[h,w] = size(winnerOrientations);
wM1 = width - 1;
numPatches = h*w;

patchesRGB = zeros(3*width^2,numPatches,'uint8');
patchesYCbCr = zeros(3*width^2,numPatches,'uint8');
blockNum = 1;

for i = 1 : h
    disp(['row: ' num2str(i) ' out of ' num2str(h)]);
    for j = 1 : w
        blockRGB = paddedRGB(i:i+wM1+2*padSize,j:j+wM1+2*padSize,:);
        angle = rad2deg(winnerOrientations(i,j)); % imrotate works counter-clockwise (and our angles are clockwise) so we are good
        if (angle==0)
            rotBlock = blockRGB;
        else
            rotBlock = imrotate(blockRGB,double(angle),'nearest','crop');
        end
        finalBlock = rotBlock(padSize+1:end-padSize,padSize+1:end-padSize,:);
        patchesRGB(:,blockNum) = finalBlock(:);
%         imshow2(blockRGB,finalBlock); set(gcf,'Name',['angle=' num2str(angle)]);
        finalBlockYCbCr = rgb2ycbcr(finalBlock);
        patchesYCbCr(:,blockNum) = finalBlockYCbCr(:);
        blockNum = blockNum + 1;
    end
end