function histImg = GetHistogramOrientations(binsImg,magnitudes,width,nbins)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[h,w] = size(binsImg);

histImg = zeros(nbins,h,w); % the output histogram (will hold values in the range {1,2,...,nbins})

g = fspecial('gaussian',width,width/2); % we can play around with sig=width/2
%     g = ones(width);
% truncate the gaussian to be circular
center = 0.5*(width+1);
for i = 1 : width
    for j = 1 : width
        if (sqrt((i-center)^2+(j-center)^2)>=center-0.5)
            g(i,j) = 0;
        end
    end
end

% fill the histogram
widM1 = width - 1;
for j = 1 : w - widM1
    disp(['hist for column ' num2str(j) ' out of ' num2str(w - widM1)]);
    for i = 1 : h - widM1
        % extract the block
        block = binsImg(i:i+widM1,j:j+widM1);
        magsBlock = g.*magnitudes(i:i+widM1,j:j+widM1); % weighted by a centered gaussian
        
        % collect block elements into histogram, weighted by the weighted mags
        for ind = 1 : width^2
            histImg(block(ind),i,j) = histImg(block(ind),i,j) + magsBlock(ind);
        end
    end
end