function winnerOrientations = GetWinnerOrientationPerBlock(binsImg,bestBins,magnitudes,pixOrients,width)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

widM1 = width - 1;
[h,w] = size(bestBins);
winnerOrientations = zeros(h - widM1,w - widM1);
g = fspecial('gaussian',width,width/2); % we can play around with sig=width/2
for j = 1 : w - widM1
    for i = 1 : h - widM1
        % extract the block
        block = binsImg(i:i+widM1,j:j+widM1);
        magsBlock = g.*magnitudes(i:i+widM1,j:j+widM1); % weighted by a centered gaussian
        origOrientations = pixOrients(i:i+widM1,j:j+widM1);
        
        % weighted average
        weights = magsBlock(block==bestBins(i,j));
        if (sum(weights)>0)
            weights = weights/sum(weights);
        end
        orientations = origOrientations(block==bestBins(i,j));
        winnerOrientations(i,j) = sum(weights.*orientations);
    end
end