function [filter_mat] = get_filter_from_ind_VIDEO(indices)
filter_mat = ones(4,4,4, 'int8');
if length(indices) ~= 3
    error('number of indices must be 3 !');
end

filter_mat = applay_dim1_proj(filter_mat,indices(1));
filter_mat = applay_dim2_proj(filter_mat,indices(2));
filter_mat = applay_dim3_proj(filter_mat,indices(3));

% for dim = 1:3
%     if indices(dim) == 0
%         continue
%     end
%     filter_mat = applay_dim_proj(filter_mat,dim,indices(i));
% end

function filter_mat = applay_dim1_proj(filter_mat,val)
kernel = ones(4,4,4,'int8');
switch val
    case 1
        kernel(1:2,:,:) = -1;
    case 2
        kernel(2:3,:,:) = -1;
end
filter_mat = filter_mat.*kernel;

function filter_mat = applay_dim2_proj(filter_mat,val)
kernel = ones(4,4,4,'int8');
switch val
    case 1
        kernel(:,1:2,:) = -1;
    case 2
        kernel(:,2:3,:) = -1;
end
filter_mat = filter_mat.*kernel;

function filter_mat = applay_dim3_proj(filter_mat,val)
kernel = ones(4,4,4,'int8');
switch val
    case 1
        kernel(:,:,1:2) = -1;
    case 2
        kernel(:,:,2:3) = -1;
end
filter_mat = filter_mat.*kernel;
    