function [currFiltImgs_A, currFiltImgs_B] = ...
    ModifyBoundaries_VIDEO(currFiltImgs_A, currFiltImgs_B,largeVal,calcBnn,width, mask)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
LargeValDiv2 = floor(largeVal / 2);

if (~calcBnn)
    for kernel_ind = 1 : length(currFiltImgs_B{1})% 6
        if (kernel_ind > 1)
            largeVal = LargeValDiv2;
        end
        % for each filter:
        % 1] dark out the first frame
        currFiltImgs_B{1}{kernel_ind}(:) = largeVal;
        
        % 2] dark out the last (width-1) rows and columns, for each frame as well as masked pixels
        for frame = 2 : length(currFiltImgs_B) - width
            currFiltImgs_B{frame}{kernel_ind}(:, end-width+1:end) = largeVal;
            currFiltImgs_B{frame}{kernel_ind}(end-width+1:end, :) = largeVal;       
            currFiltImgs_B{frame}{kernel_ind}(end-width+1:end, :) = largeVal;       
            if (~isempty(mask))
                currFiltImgs_B{kernel_ind}(mask{frame} == 1) = largeVal;
            end
        end
        
        % 4] dark out the last (width-1) frames
        for frame = length(currFiltImgs_B) - width + 1 : length(currFiltImgs_B)
            currFiltImgs_B{frame}{kernel_ind}(:) = largeVal;
        end
                
    end
else
    for kernel_ind = 1 : length(currFiltImgs_A)% 6
        if (kernel_ind > 1)
            largeVal = LargeValDiv2;
        end
        % for each filter:
        % 1] dark out the first frame
        currFiltImgs_A{1}{kernel_ind} = largeVal;
        
        % 2] dark out the last (width-1) rows and columns, for each frame as well as masked pixels
        for frame = 2 : length(currFiltImgs_A) - width
            currFiltImgs_A{frame}{kernel_ind}(:, end-width+1:end) = largeVal;
            currFiltImgs_A{frame}{kernel_ind}(end-width+1:end, :) = largeVal;       
            currFiltImgs_A{frame}{kernel_ind}(end-width+1:end, :) = largeVal;       
            if (~isempty(mask))
                currFiltImgs_A{kernel_ind}(mask{frame} == 1) = largeVal;
            end
        end
        
        % 4] dark out the last (width-1) frames
        for frame = length(currFiltImgs_A) - width + 1 : length(currFiltImgs_A)
            currFiltImgs_A{frame}{kernel_ind} = largeVal;
        end
                
    end
end
