function normalMap = CalculateNormals(X,Y,Z,nnRadius,bShowImage)

Threshold = 2*nnRadius*nnRadius;
patchsize = [(2*nnRadius+1)^2 1];
[height,width] = size(Z);

normalMap = zeros(height,width,3);

for i= (1+nnRadius):(height-nnRadius)
    if mod(i,10)==0
        fprintf('Normals for line %d out of %d\n',i,height-nnRadius);
    end
    i_inds = i-nnRadius:i+nnRadius;
    for j=(1+nnRadius):(width-nnRadius)       
        j_inds = j-nnRadius:j+nnRadius;
        patch(:,1) = reshape(X(i_inds,j_inds),patchsize);
        patch(:,2) = reshape(Y(i_inds,j_inds),patchsize);
        patch(:,3) = reshape(Z(i_inds,j_inds),patchsize);
        
        patchMask = patch(:,3);
        patchMask = patchMask>0;
        
        if (sum(sum(patchMask))>Threshold)
            normalMap(i,j,:) = CalcPatchNormal(patch(patchMask,:));
            normalMap(i,j,:) = normalMap(i,j,:)*sign(normalMap(i,j,3));
        end
    end
end

if (bShowImage)
    imshow(.5*(normalMap+1));
end