function defaults = Default_Values()

defaults.loadPatchesPath = 'c:\DCSH_Temp\'; %Path for Saving program temporal code calculations
% ioPath   : Folder path of source files (requirements : RGB (Cleaned/Noisy),Depth file, Optional : groundTruthRGB)
defaults.ioPath             = pwd;
defaults.inputType          = 'RGBD'; %'RGBD'\'TIFF' %The type of file that hold the depth File
defaults.rgbImageName       = 'rgbImage.bmp'; %Name and extension of the RGB Image
defaults.rgbdFileName       = 'RGBD.mat';      %Name and extension of the 4-D RGBD file
defaults.depthImageName     = 'depthImage16bit.tiff'; %Name and extension Depth TIFF file
defaults.gtRGBImageName = 'rgbImage.bmp';          %Name of the ground RGB Image (optional)
c = clock; %c :[year month day hour minute seconds]

defaults.logFolderName      =  ['date:' num2str(c(3)) '-' num2str(c(2)) '-' num2str(c(1)) '-time:' num2str(c(4)) ':' num2str(c(5))]; %name to be included in the log folder in order to allow future loading of pre computed parts
defaults.noiseSigmaRGB      = 25;     %Value of the RGB channels noise

%% Advanced parameters
defaults.patchResolution    = 8;     %Patch size Size in pixels

% Normals
defaults.xyWeight = 0.5;  %Weights for clusters calcualation, giving lower weight to the x,y cordinates
defaults.depthWeight = 1; %Weights for clusters calcualation of the depth
defaults.nnRadius           = 3;     %Normals calculation support
defaults.bFitPlane   = false;

% combined RGB and depth matches
defaults.socialMatch = true; %Run social CSH mechanism (Finding neigbours of seed nearest neigbours)
defaults.loadCluster = true;        %if exists load precomputed clusters homographies
defaults.loadClusterMatches = true; %if exists load precomputed clusters matches

% RGB only
defaults.knnCountImage  = 10;     %The number of seed nearest neighours in the image plain

% visualize
defaults.showImages    = true;
defaults.showMatches   = false; %show top 50 nearest patches for each pixel
defaults.showPCAOutput = false; %Show original noisy patch vs. the patch after PCA output
defaults.showLowTextureMask = false;
defaults.numOfPlots = 100; %The number of times I would like to see visual output

% cluster
defaults.clusterCount = 10; %Number of prototypical view points
defaults.knnCountClusters = 10; % Number of seed nearest neighours in each view point

% CSH
defaults.cshIterations = 6;
defaults.cshCalcBNN = 0;
defaults.cshMask = [];
defaults.cshPatchMode = 1;
defaults.cshK = defaults.knnCountClusters;
defaults.cshRotationInvariant = 1;

% matching
defaults.interpMethod =  'nearest'; % 'cubic'; % 'linear'
defaults.projectionRatioTH = 0.75;
defaults.knnCountSampling = 200; %The final number of desired neighbours for each patch
defaults.sigmaN = 20; %The sigma of the noise add to the clean image
defaults.diff2LowThreshold = 0; % 30;
defaults.lowTextureThresh = 30;
defaults.diffGaussianSigma = 4;

% reconstruction
defaults.weightsGaussianSigma = 2;
defaults.projectAllPatches = false;% if false use only one patch

end