function [planeX, planeY, planeZ, planeNormal] = FitDepthPlane(X,Y,Z,K)
fprintf(2,'FitDepthPlane\n');
[height, width] = size(Z);

planeX = zeros(height,width);
planeY = zeros(height,width);
planeZ = zeros(height,width);

mask = ~(Z==0);
patch(:,1) = X(mask);
patch(:,2) = Y(mask);
patch(:,3) = Z(mask);
[planeNormal,planeP0] = RansacPlaneFit(patch);

for i= 1:height
    for j=1:width              
    x = [j i 1]';        
    ray = (K \ x);
    ray = ray/ray(3);
    z = (planeP0*planeNormal)/(ray'*planeNormal);
    planeZ(i,j) = z;
    planeX(i,j) = z*ray(1);
    planeY(i,j) = z*ray(2);
    end
end
end