function histImg = GetHistogramOrientations(binsImg,magnitudes,patchResolution,nbins)

[h,w] = size(binsImg);

hHist = h/patchResolution;
wHist = w/patchResolution;

histImg = zeros(nbins,hHist,wHist); % the output histogram (will hold values in the range {1,2,...,nbins})

g = fspecial('gaussian',patchResolution+1,patchResolution/4); % we can play around with sig=width/2
g = g(1:end-1,1:end-1);
g = g/sum(sum(g));

%%% set boundry to zero
g(1,:) = 0;
g(end,:) = 0;
g(:,1) = 0;
g(:,end) = 0;

patchResolution2 = patchResolution^2;
% fill the histogram
widM1 = patchResolution - 1;
for j = 1 : wHist
    jb=1+(j-1)*patchResolution;
    for i = 1 : hHist
        % extract the block
        ib=1+(i-1)*patchResolution;
        block = binsImg(ib:ib+widM1,jb:jb+widM1);
        magsBlock = g.*magnitudes(ib:ib+widM1,jb:jb+widM1); % weighted by a centered gaussian
        
        % collect block elements into histogram, weighted by the weighted mags
        for ind = 1 : patchResolution2
            histImg(block(ind),i,j) = histImg(block(ind),i,j) + magsBlock(ind);
        end
    end
end