function winnerOrientations = GetWinnerOrientationPerBlock(binsImg,bestBins,magnitudes,pixOrients,patchResolution)

widM1 = patchResolution - 1;
[h,w] = size(bestBins);
winnerOrientations = zeros(h,w);

g = fspecial('gaussian',patchResolution,patchResolution/2); % we can play around with sig=width/2

%%% set boundry to zero
g(1,:) = 0;
g(end,:) = 0;
g(:,1) = 0;
g(:,end) = 0;

for j = 1 : w
    for i = 1 : h
        % extract the block
        ib=1+(i-1)*patchResolution;
        jb=1+(j-1)*patchResolution;
        block = binsImg(ib:ib+widM1,jb:jb+widM1);
        magsBlock = g.*magnitudes(ib:ib+widM1,jb:jb+widM1); % weighted by a centered gaussian
        origOrientations = pixOrients(ib:ib+widM1,jb:jb+widM1);
        
        % weighted average
        weights = magsBlock(block==bestBins(i,j));
        if (sum(weights)>0)
            weights = weights/sum(weights);
        end
        orientations = origOrientations(block==bestBins(i,j));
        winnerOrientations(i,j) = sum(weights.*orientations);
    end
end