function [orientedHomographyArray] = RenormalizePatchesWithOrientationLocal(homographyArray,orientationArray,iRange,jRange)

%%% frontal patch at z=1 will occupy ~ 2*patchRadius*f

minI = iRange(1);
maxI = iRange(end);
minJ = jRange(1);
maxJ = jRange(end);

orientedHomographyArray = homographyArray;

%% homography+orientation loop
for i= minI:maxI
    for j= minJ:maxJ
        % skip when homographyMask==0 or orientation=eye
        if (sum(abs(homographyArray(i,j)))==0)
            continue
        end
        H = reshape(homographyArray(i,j,:),[3 3]);
        R = reshape(orientationArray(i,j,:),[3 3]);
        HR = H*R;
        orientedHomographyArray(i,j,:) = reshape(HR,[1 9]);
    end
end