%%% exercise 2.1 - homography 

function H = calcH(p1,p2)

%%% LS methods - SVD pr QR
bSolveSVD = false;
bSolveQR = true;

%%% input p1, p2 : 2xn

p1 = p1';
p2 = p2';

A = [p1(:,1) , p1(:,2) ,ones(length(p1),1) , zeros(length(p1),3) , -p2(:,1).*p1(:,1) , -p2(:,1).*p1(:,2) , -p2(:,1)];
A = [A ; zeros(length(p1),3), p1(:,1) , p1(:,2) ,ones(length(p1),1), -p2(:,2).*p1(:,1) , -p2(:,2).*p1(:,2) , -p2(:,2)];
%%% constraint - sum of H elements = 1
A = [A ; ones(1,9)];

b = [zeros(length(p1)*2,1) ; 1];

%%% h = [H11 H12 H13 H21 H22 H23 H31 H32 H33]'

%% Least Squares

if (bSolveQR)
%% QR factorization
[Q,R] = qr(A);
y = Q'*b;
h = R\y;

% refinement step
% r = b - A*h; 
% y = Q'*r;
% e = R\y
% h = h+e;

%%% alternative:
% R = triu(qr(A));
% h = R\(R'\(A'*b));
% r = b-A*h;
% e = R\(R'\(A'*r));
% h = h+e;

else
    if (bSolveSVD)
%% SVD

[U,S,V] = svd(A);

diagS = diag(S);
Sinv = S;

for i=1:length(diagS)
    if (diagS(i) > 1e-6)
        Sinv(i,i) = 1/diagS(i);
    else
        Sinv(i,i) = diagS(i);    
    end
end

%%% alternative
% Sinv = S;
% So = S;
% Sinv(S<1e-6) = inf;
% Sinv = 1./Sinv;
% So(S>1e-6) = 0;
%  Sinv = Sinv+So;

Sinv = Sinv';

Ainv = V*Sinv*U';     %%% Ainv*A = (V*Sinv*U')*(U*S*V') =I
h = Ainv*b;

    else        
     h = A \ b;   
    end
end

H = reshape(h,3,3)';  % transpose
